{% extends "operators/base.html" %}{% load i18n l10n static %}{% get_current_language as LANGUAGE_CODE %}
{% block title %}{% if problematic %}{% trans "Problematic locations" %}{% else %}{% trans "Locations" %}{% endif %}{% endblock %}
{% block extrahead %}
<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
<link rel="stylesheet" type="text/css" href="{% static 'datatables1/datatables.min.css' %}"/>
<script type="text/javascript" src="{% static 'datatables1/datatables.min.js' %}"></script>
{% endblock %}
{% block content %}

<div class="page-header row mb-4">
    <div class="col-lg-8">
        <h1>{% if problematic %}{% trans "Problematic locations" %}{% else %}{% trans "Locations" %}{% endif %}</h1>
    </div>
    {% if not problematic %}
    <div class="col-lg-4 text-end">
        <a class="btn btn-lg btn-warning" href="{% url 'operators:problematic-locations-list' %}">
            <i class="fas fa-question-circle"></i>
        </a>
        <a class="btn btn-lg btn-success" href="{% url 'operators:new-location' %}">
            <i class="fas fa-plus"></i>
            &nbsp; {% trans "Add location" %}
        </a>
    </div>
    {% endif %}
</div>

{% if not problematic %}
<div class="pb-5">
    <div id="map" style="height: 600px;" class="mb-4"></div>
    <p id="map-navigation-keys-hint" class="text-end mx-3 my-2"><kbd>Ctrl</kbd>&nbsp;+&nbsp;<kbd>Alt</kbd> {% trans "to navigate the map using the mouse." %}</p>
</div>
{% endif %}

<table class="table table-striped" id="table">
    <thead>
    <tr>
        <th>{% trans "Name" %}</th>
        <th>{% trans "Address" %}</th>
        <th>{% trans "Coordinates" %}</th>
        <th></th>
    </tr>
    </thead>
    <tbody>
        {% for o in object_list %}
        <tr>
            <td>{{ o.name|default:"-" }}</td>
            <td>
                {{ o.address }}
                {% if problematic %}
                    {% if o.senior_set.all %}<br>
                        <i class="fas fa-home"></i> &nbsp; {% for i in o.senior_set.all %}{{ i.get_official_name }}{% if not forloop.last %},{%  endif %} {% endfor %}
                    {% endif %}
                    {% if o.tripstage_set.all %}<br>
                        <i class="fas fa-map-pin"></i> &nbsp; {% for i in o.tripstage_set.all %}
                        <a href="{% url 'operators:edit-reservation' pk=i.reservation.pk %}" target="_blank">{{ i }}</a>{% if not forloop.last %},{%  endif %}
                        {% endfor %}
                    {% endif %}
                {% endif %}
            </td>
            <td>{{ o.lat|unlocalize }}, {{ o.lng|unlocalize }}</td>
            <td>
                <a href="{% url 'operators:edit-problematic-locations-list' pk=o.pk %}" class="btn btn-lg btn-primary">
                    <i class="fas fa-edit"></i>
                </a>
            </td>
        </tr>
        {% endfor %}
    </tbody>
</table>

<script type="text/javascript">
    $(document).ready(function() {
        var disableMapInteraction = function(map) {
            map.dragging.disable();
            map.touchZoom.disable();
            map.doubleClickZoom.disable();
            map.scrollWheelZoom.disable();
            map.boxZoom.disable();
            map.keyboard.disable();
            if (map.tap) {
                map.tap.disable();
            }
        };

        var enableMapInteraction = function(map) {
            map.dragging.enable();
            map.touchZoom.enable();
            map.doubleClickZoom.enable();
            map.scrollWheelZoom.enable();
            map.boxZoom.enable();
            map.keyboard.enable();
            if (map.tap) {
                map.tap.enable();
            }
        };

        // table
        $("#table").dataTable({language: {url: "{% static 'datatables1/i18n/'|add:LANGUAGE_CODE|add:"_"|add:LANGUAGE_CODE|add:'.json' %}"}});

        // map configuration
        window.map = L.map('map').setView({{ MAP_DEFAULT_VIEW|safe }}, 13);
        window.layergroup = L.layerGroup().addTo(window.map);
        var tiles = L.tileLayer('//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 18,
            minZoom: 2,
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(window.map);
        {% for o in object_list %}
            {% if o.lat and o.lng and not problematic %}
                L.marker([{{ o.lat|safe }}, {{ o.lng|safe }}])
                    .addTo(window.layergroup)
                    .bindPopup("<b>{{ o.name }}</b><br>{{ o.address }}<br><a href=\"{% url 'operators:edit-location' pk=o.pk %}\">{% trans 'Edit' %}</a>");
            {% endif %}
        {% endfor %}

        // setup map interaction with ctrl+alt key combination
        if (!Modernizr.touchevents) {
            disableMapInteraction(window.map);
            window.map.on('keydown', function (evt) {
                if (evt.originalEvent.ctrlKey && evt.originalEvent.which === 18) {
                    evt.originalEvent.preventDefault();
                    enableMapInteraction(window.map);
                }
            });
            window.map.on('keyup', function (evt) {
                if (evt.originalEvent.which === 18) {
                    evt.originalEvent.preventDefault();
                    disableMapInteraction(window.map);
                }
            });
            document.addEventListener('keydown', function (evt) {
                if (evt.ctrlKey && evt.which === 18) {
                    evt.preventDefault();
                    enableMapInteraction(window.map);
                }
            });
            document.addEventListener('keyup', function (evt) {
                if (evt.which === 18) {
                    evt.preventDefault();
                    disableMapInteraction(window.map);
                }
            });
        } else {
            $('#map-navigation-keys-hint').hide();
        }
    });
</script>
<script src="{% static 'modernizr3-touchevents/touchevents.js' %}"></script>

{% endblock %}